;;;Get current user specified (by layername) model space viewport number.
;;;
;;;Layer name must contain "VI##" where ## is a two digit user specified
;;;view number.  Otherwise you are prompted for the view number.
;;;the variable prod is set to "VI##".  (C:MKLAYR) is used to preserve and
;;;then restore the current layer after this function.  Use (C:SVLAYR) before
;;;this function, (C:MKLAYER) during this function and (C:RSLAYR) after.
;;;If the current space is Paper space then prod is not set.
;;;
;;;	Author:
;;;		Henry C. Francis
;;;		425 N. Ashe Street
;;;		Southern Pines, NC 28387
;;;
;;;	http://paracadd.com
;;;	All rights reserved.
;;;
;;;
(DEFUN gvpno (/ curvno cvpss cvpent cvpename lnccnt)
;;;  (IF (OR (NOT LAYOUTLIST) (IF LAYOUTLIST (=(LENGTH(LAYOUTLIST))1)))
  (SETQ old_gvpno_cmdecho (GETVAR "cmdecho"))
  (SETVAR "cmdecho" 0)
  (PROGN
    (IF uint
      NIL
      (LOAD "uint" "\nFile UINT.LSP not loaded! ")
    ) ;_ end of IF
    (IF ukword
      NIL
      (LOAD "ukword" "\nFile UKWORD.LSP not loaded! ")
    ) ;_ end of IF
    (SETQ viewno nil)
    (SETQ curvno (GETVAR "cvport"))
    (IF ForceMyUcsIcon
      (COMMAND ".ucsicon" "All" ForceMyUcsIcon)
    ) ;_ end of IF
    (IF (AND (> curvno 1) (EQ (GETVAR "tilemode") 0))
      (PROGN
        (SETQ as_67 0)
        (SETQ cvpss (SSGET "X" (LIST (CONS 410 (GETVAR "CTAB")) (CONS 69 curvno))))
        (SETQ cvpent (ENTGET (SSNAME cvpss 0)))
        (SETQ cvpename (CDR (ASSOC -1 cvpent)))
        (SETQ cvplay (CDR (ASSOC 8 cvpent)))
        (IF (AND ForceMyViewres (< (CDR (ASSOC 72 cvpent)) ForceMyViewres))
          (COMMAND ".viewres" "y" ForceMyViewres)
        ) ;_ end of IF
        (IF (WCMATCH (STRCASE (GETVAR "DWGNAME")) "*PLAN & PROFILE*")
          (SETQ mjrg "C")
          (PROGN
            (IF set_mjrg NIL (LOAD "SET_MJRG" "\nFile SET_MJRG.LSP not loaded! "))
            (set_mjrg)
          )
        )
        (SETQ vplmjr mjrg)
        (IF (WCMATCH (STRCASE cvplay) "??VI##*")
          (PROGN (SETQ lnccnt 1)
                 (WHILE (NOT (WCMATCH (SETQ vp_str (STRCASE (SUBSTR cvplay lnccnt))) "VI##*"))
                   (SETQ lnccnt (1+ lnccnt))
                 ) ;_ end of while
                 (SETQ prod (SUBSTR vp_str 1 4))
                 (SETQ viewno (ATOI (SUBSTR vp_str 3 2)))
          ) ;_ end of progn
          (PROGN
            (SETQ viewno (uint 1 "" "Viewport number for CLG layer name Minor group \"VI##\" (## = 0-99)?" viewno))
            (WHILE (AND viewno (OR (< viewno 0) (> viewno 99)))
              (SETQ viewno (uint 1 "" "Viewport number for CLG layer name Minor group \"VI##\" (## = 0-99)?" viewno))
            ) ;_ end of WHILE
            (IF (< viewno 10)
              (SETQ prod (STRCAT "VI0" (ITOA viewno)))
              (SETQ prod (STRCAT "VI" (ITOA viewno)))
            ) ;_ end of if
            (SETQ new_nplt_lay (STRCASE (STRCAT vplmjr "-" prod "7nplt")))
            (SETQ fixvpl
                   (ukword 1 "Yes No" (STRCAT "Change viewport layer to:" new_nplt_lay " (non-plot boundary)") "Yes")
            ) ;_ end of SETQ
            (IF (EQ fixvpl "Yes")
              (PROGN (COMMAND ".pspace")
                     (COMMAND "-layer" "m" new_nplt_lay "")
                     (IF (AND (ASSOC 340 cvpent) (ASSOC 8 (ENTGET (CDR (ASSOC 340 cvpent)))))
                       (PROGN (COMMAND ".chprop" (CDR (ASSOC 340 cvpent)) "" "la" new_nplt_lay ""))
                     ) ;_ end of IF
                     (COMMAND ".chprop" cvpename "" "la" new_nplt_lay "")
                     (COMMAND ".mspace")
              ) ;_ end of progn
              (PROGN (SETQ change_mjrg
                            (ukword 1
                                    "A C E F G I L M O P Q S T Z None"
                                    "Select another CLG major group [A C E F G I L M O P Q S T Z None]"
                                    change_mjrg
                            ) ;_ end of ukword
                     ) ;_ end of SETQ
                     (IF (NOT (EQ change_mjrg "None"))
                       (PROGN (SETQ new_nplt_lay (STRCASE (STRCAT change_mjrg "-" prod "7nplt")))
                              (SETQ fixvpl (ukword 1 "Yes No" (STRCAT "Change viewport layer to " new_nplt_lay) "Yes"))
                              (IF (EQ fixvpl "Yes")
                                (PROGN (COMMAND ".pspace")
                                       (COMMAND "-layer" "m" new_nplt_lay "")
                                       (IF (AND (ASSOC 340 cvpent) (ASSOC 8 (ENTGET (CDR (ASSOC 340 cvpent)))))
                                         (PROGN (COMMAND ".chprop" (CDR (ASSOC 340 cvpent)) "" "la" new_nplt_lay ""))
                                       ) ;_ end of IF
                                       (COMMAND ".chprop" cvpename "" "la" new_nplt_lay "")
                                       (COMMAND ".mspace")
                                ) ;_ end of progn
                              ) ;_ end of IF
                       ) ;_ end of PROGN
                     ) ;_ end of IF
              ) ;_ end of PROGN
            ) ;_ end of if
          ) ;_ end of progn
        ) ;_ end of if
      ) ;_ end of progn
      (PROGN (SETQ as_67 1)) ;_ end of progn
    )          ;if
               ;  (if prod nil
               ;    (setq prod "PLAN")
               ;  )
  ) ;_ end of PROGN
  (SETVAR "cmdecho" old_gvpno_cmdecho)
  (PRINC)
) ;_ end of defun


 ;|Visual LISP Format Options
(120 2 15 2 T "end of " 100 9 2 0 nil nil nil T T)
;*** DO NOT add text below the comment! ***|;
